unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, sgmMagneticControls, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    GroupBox2: TGroupBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    CheckBox9: TCheckBox;
    CheckBox10: TCheckBox;
    Panel1: TPanel;
    procedure CheckBox10Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox8Click(Sender: TObject);
    procedure CheckBox9Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Panel1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  protected
    fMouseDown: Boolean;
    fSavedOffset: TPoint;
    sgmMagneticForm1: TsgmMagneticForm;
    sgmMagneticControl1: TsgmMagneticControl;
  end;

var
  Form1: TForm1;

implementation

uses Types;

{$R *.dfm}

procedure TForm1.CheckBox10Click(Sender: TObject);
begin
  CheckBox5.Enabled := CheckBox10.Checked;
  CheckBox6.Enabled := CheckBox10.Checked;
  CheckBox7.Enabled := CheckBox10.Checked;
  CheckBox8.Enabled := CheckBox10.Checked;
  sgmMagneticForm1.ActiveSizing := CheckBox10.Enabled;
  CheckBox10.Enabled := sgmMagneticForm1.ActiveSizing;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if Sender = CheckBox1 then
    case CheckBox1.Checked of
      False: sgmMagneticForm1.MovingBorders := sgmMagneticForm1.MovingBorders - [mbLeft];
      True: sgmMagneticForm1.MovingBorders := sgmMagneticForm1.MovingBorders + [mbLeft];
    end;
  if Sender = CheckBox2 then
    case CheckBox2.Checked of
      False: sgmMagneticForm1.MovingBorders := sgmMagneticForm1.MovingBorders - [mbTop];
      True: sgmMagneticForm1.MovingBorders := sgmMagneticForm1.MovingBorders + [mbTop];
    end;
  if Sender = CheckBox3 then
    case CheckBox3.Checked of
      False: sgmMagneticForm1.MovingBorders := sgmMagneticForm1.MovingBorders - [mbRight];
      True: sgmMagneticForm1.MovingBorders := sgmMagneticForm1.MovingBorders + [mbRight];
    end;
  if Sender = CheckBox4 then
    case CheckBox4.Checked of
      False: sgmMagneticForm1.MovingBorders := sgmMagneticForm1.MovingBorders - [mbBottom];
      True: sgmMagneticForm1.MovingBorders := sgmMagneticForm1.MovingBorders + [mbBottom];
    end;
end;

procedure TForm1.CheckBox8Click(Sender: TObject);
begin
  if Sender = CheckBox5 then
    case CheckBox5.Checked of
      False: sgmMagneticForm1.SizingBorders := sgmMagneticForm1.MovingBorders - [mbLeft];
      True: sgmMagneticForm1.SizingBorders := sgmMagneticForm1.MovingBorders + [mbLeft];
    end;
  if Sender = CheckBox6 then
    case CheckBox6.Checked of
      False: sgmMagneticForm1.SizingBorders := sgmMagneticForm1.MovingBorders - [mbTop];
      True: sgmMagneticForm1.SizingBorders := sgmMagneticForm1.MovingBorders + [mbTop];
    end;
  if Sender = CheckBox7 then
    case CheckBox7.Checked of
      False: sgmMagneticForm1.SizingBorders := sgmMagneticForm1.MovingBorders - [mbRight];
      True: sgmMagneticForm1.SizingBorders := sgmMagneticForm1.MovingBorders + [mbRight];
    end;
  if Sender = CheckBox8 then
    case CheckBox8.Checked of
      False: sgmMagneticForm1.SizingBorders := sgmMagneticForm1.MovingBorders - [mbBottom];
      True: sgmMagneticForm1.SizingBorders := sgmMagneticForm1.MovingBorders + [mbBottom];
    end;
end;

procedure TForm1.CheckBox9Click(Sender: TObject);
begin
  CheckBox1.Enabled := CheckBox9.Checked;
  CheckBox2.Enabled := CheckBox9.Checked;
  CheckBox3.Enabled := CheckBox9.Checked;
  CheckBox4.Enabled := CheckBox9.Checked;
  sgmMagneticForm1.ActiveMoving := CheckBox9.Enabled;
  CheckBox9.Enabled := sgmMagneticForm1.ActiveMoving;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  sgmMagneticForm1 := TsgmMagneticForm.Create(Form1);
  sgmMagneticForm1.Indent := 50;
  sgmMagneticControl1 := TsgmMagneticControl.Create(Form1);
  sgmMagneticControl1.Indent := 50;
  sgmMagneticControl1.Control := Panel1;
end;

procedure TForm1.Panel1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  Panel1.Perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TForm1.Panel1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  PT: TPoint;
begin
  if fMouseDown then
  begin
    PT := Point(X, Y);
    PT := Panel1.ClientToParent( PT );
    Panel1.Left := PT.X - fSavedOffset.X;
    Panel1.Top := PT.Y - fSavedOffset.Y;
  end;
end;

end.
